Index: org/postgresql/test/jdbc2/DateTest.java
===================================================================
RCS file: /projects/cvsroot/pgsql-server/src/interfaces/jdbc/org/postgresql/test/jdbc2/DateTest.java,v
retrieving revision 1.5
diff -c -p -r1.5 DateTest.java
*** org/postgresql/test/jdbc2/DateTest.java	14 Aug 2002 20:35:40 -0000	1.5
--- org/postgresql/test/jdbc2/DateTest.java	10 Jul 2003 15:53:12 -0000
*************** public class DateTest extends TestCase
*** 15,20 ****
--- 15,21 ----
  {
  
  	private Connection con;
+ 	private boolean testingSetDate = false;
  
  	public DateTest(String name)
  	{
*************** public class DateTest extends TestCase
*** 46,56 ****
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'1970-06-02'")));
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'1999-08-11'")));
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'2001-02-13'")));
  
  			/* dateTest() contains all of the tests */
  			dateTest();
  
! 			assertEquals(4, stmt.executeUpdate("DELETE FROM " + "testdate"));
  			stmt.close();
  		}
  		catch (Exception ex)
--- 47,69 ----
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'1970-06-02'")));
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'1999-08-11'")));
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'2001-02-13'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'1950-04-02'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'1970-11-30'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'1988-01-01'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'2003-07-09'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'1934-02-28'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'1969-04-03'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'1982-08-03'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'2012-03-15'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'1912-05-01'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'1971-12-15'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'1984-12-03'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testdate", "'2000-01-01'")));
  
  			/* dateTest() contains all of the tests */
  			dateTest();
  
! 			assertEquals(16, stmt.executeUpdate("DELETE FROM " + "testdate"));
  			stmt.close();
  		}
  		catch (Exception ex)
*************** public class DateTest extends TestCase
*** 80,92 ****
  
  			ps.setDate(1, makeDate(2001, 2, 13));
  			assertEquals(1, ps.executeUpdate());
! 
  			ps.close();
  
  			// Fall through helper
  			dateTest();
  
! 			assertEquals(4, stmt.executeUpdate("DELETE FROM testdate"));
  			stmt.close();
  		}
  		catch (Exception ex)
--- 93,156 ----
  
  			ps.setDate(1, makeDate(2001, 2, 13));
  			assertEquals(1, ps.executeUpdate());
! 			
! 			ps.setObject(1, java.sql.Timestamp.valueOf("1950-04-02 12:00:00"), java.sql.Types.DATE);
! 			assertEquals(1, ps.executeUpdate());
! 			
! 			ps.setObject(1, java.sql.Timestamp.valueOf("1970-11-30 3:00:00"), java.sql.Types.DATE);
! 			assertEquals(1, ps.executeUpdate());
! 			
! 			ps.setObject(1, java.sql.Timestamp.valueOf("1988-1-1 13:00:00"), java.sql.Types.DATE);
! 			assertEquals(1, ps.executeUpdate());
! 			
! 			ps.setObject(1, java.sql.Timestamp.valueOf("2003-07-09 12:00:00"), java.sql.Types.DATE);
! 			assertEquals(1, ps.executeUpdate());
! 			
! 			ps.setObject(1, "1934-02-28", java.sql.Types.DATE);
! 			assertEquals(1, ps.executeUpdate());
! 			
! 			ps.setObject(1, "1969-04-3", java.sql.Types.DATE);
! 			assertEquals(1, ps.executeUpdate());
! 			
! 			ps.setObject(1, "1982-08-03", java.sql.Types.DATE);
! 			assertEquals(1, ps.executeUpdate());
! 			
! 			ps.setObject(1, "2012-3-15", java.sql.Types.DATE);
! 			assertEquals(1, ps.executeUpdate());
! 			
! 			ps.setObject(1, java.sql.Date.valueOf("1912-5-1"), java.sql.Types.DATE);
! 			assertEquals(1, ps.executeUpdate());
! 			
! 			ps.setObject(1, java.sql.Date.valueOf("1971-12-15"), java.sql.Types.DATE);
! 			assertEquals(1, ps.executeUpdate());
! 			
! 			ps.setObject(1, java.sql.Date.valueOf("1984-12-03"), java.sql.Types.DATE);
! 			assertEquals(1, ps.executeUpdate());
! 			
! 			ps.setObject(1, java.sql.Date.valueOf("2000-1-1"), java.sql.Types.DATE);
! 			assertEquals(1, ps.executeUpdate());
! 			
! 			ps.setObject(1, "1944-4-04-01", java.sql.Types.DATE);
! 			assertEquals(1, ps.executeUpdate());
! 			
! 			ps.setObject(1, "1970-01-1-10", java.sql.Types.DATE);
! 			assertEquals(1, ps.executeUpdate());
! 			
! 			ps.setObject(1, "1982-12-14+13", java.sql.Types.DATE);
! 			assertEquals(1, ps.executeUpdate());
! 			
! 			ps.setObject(1, "2010-08-3+05", java.sql.Types.DATE);
! 			assertEquals(1, ps.executeUpdate());
! 			
  			ps.close();
  
+ 			// Need to set a flag so that the method knows there is an extra test.
+ 			testingSetDate = true;
  			// Fall through helper
  			dateTest();
+ 			testingSetDate = false;
  
! 			assertEquals(20, stmt.executeUpdate("DELETE FROM testdate"));
  			stmt.close();
  		}
  		catch (Exception ex)
*************** public class DateTest extends TestCase
*** 127,132 ****
--- 191,296 ----
  		assertNotNull(d);
  		assertEquals(d, makeDate(2001, 2, 13));
  
+ 		assertTrue(rs.next());
+ 		d = rs.getDate(1);
+ 		assertNotNull(d);
+ 		assertEquals(d, makeDate(1950, 4, 2));
+ 
+ 		assertTrue(rs.next());
+ 		d = rs.getDate(1);
+ 		assertNotNull(d);
+ 		assertEquals(d, makeDate(1970, 11, 30));		
+ 
+ 		assertTrue(rs.next());
+ 		d = rs.getDate(1);
+ 		assertNotNull(d);
+ 		assertEquals(d, makeDate(1988, 1, 1));
+ 
+ 		assertTrue(rs.next());
+ 		d = rs.getDate(1);
+ 		assertNotNull(d);
+ 		assertEquals(d, makeDate(2003, 7, 9));
+ 		
+ 		assertTrue(rs.next());
+ 		d = rs.getDate(1);
+ 		assertNotNull(d);
+ 		assertEquals(d, makeDate(1934, 2, 28));						
+ 				
+ 		assertTrue(rs.next());
+ 		d = rs.getDate(1);
+ 		assertNotNull(d);
+ 		assertEquals(d, makeDate(1969, 4, 3));
+ 		
+ 		assertTrue(rs.next());
+ 		d = rs.getDate(1);
+ 		assertNotNull(d);
+ 		assertEquals(d, makeDate(1982, 8, 3));
+ 		
+ 		assertTrue(rs.next());
+ 		d = rs.getDate(1);
+ 		assertNotNull(d);
+ 		assertEquals(d, makeDate(2012, 3, 15));	
+ 		
+ 		assertTrue(rs.next());
+ 		d = rs.getDate(1);
+ 		assertNotNull(d);
+ 		assertEquals(d, makeDate(1912, 5, 1));	
+ 
+ 		assertTrue(rs.next());
+ 		d = rs.getDate(1);
+ 		assertNotNull(d);
+ 		assertEquals(d, makeDate(1971, 12, 15));
+ 		
+ 		assertTrue(rs.next());
+ 		d = rs.getDate(1);
+ 		assertNotNull(d);
+ 		assertEquals(d, makeDate(1984, 12, 3));
+ 
+ 		assertTrue(rs.next());
+ 		d = rs.getDate(1);
+ 		assertNotNull(d);
+ 		assertEquals(d, makeDate(2000, 1, 1));
+ 		
+ 		//now we have to convert the date, cause I fed it a timezone. IF it used it. hence the check			
+ 		if (testingSetDate)
+ 		{
+ 			assertTrue(rs.next());
+ 			d = rs.getDate(1);
+ 			assertNotNull(d);
+ 			java.sql.Date tmpDate = java.sql.Date.valueOf("1944-4-4");
+ 			int localoffset = java.util.Calendar.getInstance().getTimeZone().getOffset(tmpDate.getTime());
+ 			int Dateoffset = 60 * 60 * 1000;
+ 			tmpDate.setTime(tmpDate.getTime() + Dateoffset + localoffset);
+ 			assertEquals(d, makeDate(tmpDate.getYear() + 1900, tmpDate.getMonth()+1, tmpDate.getDate()));
+ 			
+ 			assertTrue(rs.next());
+ 			d = rs.getDate(1);
+ 			assertNotNull(d);
+ 			tmpDate = java.sql.Date.valueOf("1970-1-1");
+ 			localoffset = java.util.Calendar.getInstance().getTimeZone().getOffset(tmpDate.getTime());
+ 			Dateoffset = 10 * 60 * 60 * 1000;
+ 			tmpDate.setTime(tmpDate.getTime() + Dateoffset + localoffset);
+ 			assertEquals(d, makeDate(tmpDate.getYear() + 1900, tmpDate.getMonth()+1, tmpDate.getDate()));
+ 			
+ 			assertTrue(rs.next());
+ 			d = rs.getDate(1);
+ 			assertNotNull(d);
+ 			tmpDate = java.sql.Date.valueOf("1982-12-14");
+ 			localoffset = java.util.Calendar.getInstance().getTimeZone().getOffset(tmpDate.getTime());
+ 			Dateoffset = -13 * 60 * 60 * 1000;
+ 			tmpDate.setTime(tmpDate.getTime() + Dateoffset + localoffset);
+ 			assertEquals(d, makeDate(tmpDate.getYear() + 1900, tmpDate.getMonth()+1, tmpDate.getDate()));
+ 
+ 			assertTrue(rs.next());
+ 			d = rs.getDate(1);
+ 			assertNotNull(d);
+ 			tmpDate = java.sql.Date.valueOf("2010-08-03");
+ 			localoffset = java.util.Calendar.getInstance().getTimeZone().getOffset(tmpDate.getTime());
+ 			Dateoffset = -5 * 60 * 60 * 1000;
+ 			tmpDate.setTime(tmpDate.getTime() + Dateoffset + localoffset);
+ 			assertEquals(d, makeDate(tmpDate.getYear() + 1900, tmpDate.getMonth()+1, tmpDate.getDate()));
+ 		}
+ 		
  		assertTrue(!rs.next());
  
  		rs.close();
Index: org/postgresql/test/jdbc2/TimeTest.java
===================================================================
RCS file: /projects/cvsroot/pgsql-server/src/interfaces/jdbc/org/postgresql/test/jdbc2/TimeTest.java,v
retrieving revision 1.5
diff -c -p -r1.5 TimeTest.java
*** org/postgresql/test/jdbc2/TimeTest.java	14 Aug 2002 20:35:40 -0000	1.5
--- org/postgresql/test/jdbc2/TimeTest.java	10 Jul 2003 15:53:13 -0000
*************** public class TimeTest extends TestCase
*** 15,20 ****
--- 15,21 ----
  {
  
  	private Connection con;
+ 	private boolean testSetTime = false;
  
  	public TimeTest(String name)
  	{
*************** public class TimeTest extends TestCase
*** 44,54 ****
  
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testtime", "'01:02:03'")));
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testtime", "'23:59:59'")));
  
  			// Fall through helper
  			timeTest();
  
! 			assertEquals(2, stmt.executeUpdate("DELETE FROM testtime"));
  			stmt.close();
  		}
  		catch (Exception ex)
--- 45,62 ----
  
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testtime", "'01:02:03'")));
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testtime", "'23:59:59'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testtime", "'12:00:00'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testtime", "'05:15:21'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testtime", "'16:21:51'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testtime", "'12:15:12'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testtime", "'22:12:01'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL("testtime", "'08:46:44'")));
+ 			
  
  			// Fall through helper
  			timeTest();
  
! 			assertEquals(8, stmt.executeUpdate("DELETE FROM testtime"));
  			stmt.close();
  		}
  		catch (Exception ex)
*************** public class TimeTest extends TestCase
*** 72,82 ****
  
  			ps.setTime(1, makeTime(23, 59, 59));
  			assertEquals(1, ps.executeUpdate());
  
  			// Fall through helper
  			timeTest();
  
! 			assertEquals(2, stmt.executeUpdate("DELETE FROM testtime"));
  			stmt.close();
  			ps.close();
  		}
--- 80,117 ----
  
  			ps.setTime(1, makeTime(23, 59, 59));
  			assertEquals(1, ps.executeUpdate());
+ 			
+ 			ps.setObject(1, java.sql.Time.valueOf("12:00:00"), java.sql.Types.TIME);
+ 			assertEquals(1, ps.executeUpdate());
+ 			
+ 			ps.setObject(1, java.sql.Time.valueOf("05:15:21"), java.sql.Types.TIME);
+ 			assertEquals(1, ps.executeUpdate());			
+ 
+ 			ps.setObject(1, java.sql.Time.valueOf("16:21:51"), java.sql.Types.TIME);
+ 			assertEquals(1, ps.executeUpdate());
+ 
+ 			ps.setObject(1, java.sql.Time.valueOf("12:15:12"), java.sql.Types.TIME);
+ 			assertEquals(1, ps.executeUpdate());
+ 
+ 			ps.setObject(1, "22:12:1", java.sql.Types.TIME);
+ 			assertEquals(1, ps.executeUpdate());
+ 
+ 			ps.setObject(1, "8:46:44", java.sql.Types.TIME);			
+ 			assertEquals(1, ps.executeUpdate());			
+ 
+ 			ps.setObject(1, "5:1:2-03", java.sql.Types.TIME);
+ 			assertEquals(1, ps.executeUpdate());
+ 
+ 			ps.setObject(1, "23:59:59+11", java.sql.Types.TIME);
+ 			assertEquals(1, ps.executeUpdate());			
  
+ 			// Need to let the test know this one has extra test cases.
+ 			testSetTime = true;
  			// Fall through helper
  			timeTest();
+ 			testSetTime = false;
  
! 			assertEquals(10, stmt.executeUpdate("DELETE FROM testtime"));
  			stmt.close();
  			ps.close();
  		}
*************** public class TimeTest extends TestCase
*** 108,113 ****
--- 143,200 ----
  		assertNotNull(t);
  		assertEquals(makeTime(23, 59, 59), t);
  
+ 		assertTrue(rs.next());
+ 		t = rs.getTime(1);
+ 		assertNotNull(t);
+ 		assertEquals(makeTime(12, 0, 0), t);
+ 
+ 		assertTrue(rs.next());
+ 		t = rs.getTime(1);
+ 		assertNotNull(t);
+ 		assertEquals(makeTime(5, 15, 21), t);
+ 
+ 		assertTrue(rs.next());
+ 		t = rs.getTime(1);
+ 		assertNotNull(t);
+ 		assertEquals(makeTime(16, 21, 51), t);
+ 
+ 		assertTrue(rs.next());
+ 		t = rs.getTime(1);
+ 		assertNotNull(t);
+ 		assertEquals(makeTime(12, 15, 12), t);
+ 
+ 		assertTrue(rs.next());
+ 		t = rs.getTime(1);
+ 		assertNotNull(t);
+ 		assertEquals(makeTime(22, 12, 1), t);
+ 
+ 		assertTrue(rs.next());
+ 		t = rs.getTime(1);
+ 		assertNotNull(t);
+ 		assertEquals(makeTime(8, 46, 44), t);
+ 		
+ 		// If we're checking for timezones.
+ 		if (testSetTime)
+ 		{
+ 			assertTrue(rs.next());
+ 			t = rs.getTime(1);
+ 			assertNotNull(t);
+ 			java.sql.Time tmpTime = java.sql.Time.valueOf("5:1:2");
+ 			int localoffset = java.util.Calendar.getInstance().getTimeZone().getOffset(tmpTime.getTime());
+ 			int Timeoffset = 3 * 60 * 60 * 1000;
+ 			tmpTime.setTime(tmpTime.getTime() + Timeoffset + localoffset);
+ 			assertEquals(t, makeTime(tmpTime.getHours(), tmpTime.getMinutes(), tmpTime.getSeconds()));
+ 			
+ 			assertTrue(rs.next());
+ 			t = rs.getTime(1);
+ 			assertNotNull(t);
+ 			tmpTime= java.sql.Time.valueOf("23:59:59");
+ 			localoffset = java.util.Calendar.getInstance().getTimeZone().getOffset(tmpTime.getTime());
+ 			Timeoffset = -11 * 60 * 60 * 1000;
+ 			tmpTime.setTime(tmpTime.getTime() + Timeoffset + localoffset);
+ 			assertEquals(t, makeTime(tmpTime.getHours(), tmpTime.getMinutes(), tmpTime.getSeconds()));
+ 		}
+ 						
  		assertTrue(! rs.next());
  
  		rs.close();
Index: org/postgresql/test/jdbc2/TimestampTest.java
===================================================================
RCS file: /projects/cvsroot/pgsql-server/src/interfaces/jdbc/org/postgresql/test/jdbc2/TimestampTest.java,v
retrieving revision 1.11
diff -c -p -r1.11 TimestampTest.java
*** org/postgresql/test/jdbc2/TimestampTest.java	29 May 2003 04:39:48 -0000	1.11
--- org/postgresql/test/jdbc2/TimestampTest.java	10 Jul 2003 15:53:13 -0000
*************** public class TimestampTest extends TestC
*** 51,61 ****
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + TS2WTZ_PGFORMAT + "'")));
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + TS3WTZ_PGFORMAT + "'")));
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + TS4WTZ_PGFORMAT + "'")));
  
  			// Fall through helper
  			timestampTestWTZ();
  
! 			assertEquals(4, stmt.executeUpdate("DELETE FROM " + TSWTZ_TABLE));
  
  			stmt.close();
  		}
--- 51,78 ----
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + TS2WTZ_PGFORMAT + "'")));
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + TS3WTZ_PGFORMAT + "'")));
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + TS4WTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + TS1WTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + TS2WTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + TS3WTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + TS4WTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + TS1WTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + TS2WTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + TS3WTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + TS4WTZ_PGFORMAT + "'")));												
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + new java.sql.Timestamp(tmpDate1.getTime()) + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + new java.sql.Timestamp(tmpDate2.getTime()) + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + new java.sql.Timestamp(tmpDate3.getTime()) + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + new java.sql.Timestamp(tmpDate4.getTime()) + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + new java.sql.Timestamp(tmpTime1.getTime()) + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + new java.sql.Timestamp(tmpTime2.getTime()) + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + new java.sql.Timestamp(tmpTime3.getTime()) + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWTZ_TABLE, "'" + new java.sql.Timestamp(tmpTime4.getTime()) + "'")));
+ 			
  
  			// Fall through helper
  			timestampTestWTZ();
  
! 			assertEquals(20, stmt.executeUpdate("DELETE FROM " + TSWTZ_TABLE));
  
  			stmt.close();
  		}
*************** public class TimestampTest extends TestC
*** 89,99 ****
  
  			pstmt.setTimestamp(1, TS4WTZ);
  			assertEquals(1, pstmt.executeUpdate());
  
  			// Fall through helper
  			timestampTestWTZ();
  
! 			assertEquals(4, stmt.executeUpdate("DELETE FROM " + TSWTZ_TABLE));
  
  			pstmt.close();
  			stmt.close();
--- 106,156 ----
  
  			pstmt.setTimestamp(1, TS4WTZ);
  			assertEquals(1, pstmt.executeUpdate());
+ 			
+ 			// With java.sql.Timestamp
+ 			pstmt.setObject(1,TS1WTZ, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			pstmt.setObject(1,TS2WTZ, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			pstmt.setObject(1,TS3WTZ, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());			
+ 			pstmt.setObject(1,TS4WTZ, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			
+ 			// With Strings
+ 			pstmt.setObject(1,TS1WTZ_PGFORMAT, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			pstmt.setObject(1,TS2WTZ_PGFORMAT, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			pstmt.setObject(1,TS3WTZ_PGFORMAT, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());			
+ 			pstmt.setObject(1,TS4WTZ_PGFORMAT, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
  
+ 			// With java.sql.Date
+ 			pstmt.setObject(1,tmpDate1, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			pstmt.setObject(1,tmpDate2, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			pstmt.setObject(1,tmpDate3, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());			
+ 			pstmt.setObject(1,tmpDate4, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 		
+ 			// With java.sql.Time	
+ 			pstmt.setObject(1,tmpTime1, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			pstmt.setObject(1,tmpTime2, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			pstmt.setObject(1,tmpTime3, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());			
+ 			pstmt.setObject(1,tmpTime4, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());															
+ 			
  			// Fall through helper
  			timestampTestWTZ();
  
! 			assertEquals(20, stmt.executeUpdate("DELETE FROM " + TSWTZ_TABLE));
  
  			pstmt.close();
  			stmt.close();
*************** public class TimestampTest extends TestC
*** 120,130 ****
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + TS2WOTZ_PGFORMAT + "'")));
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + TS3WOTZ_PGFORMAT + "'")));
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + TS4WOTZ_PGFORMAT + "'")));
  
  			// Fall through helper
  			timestampTestWOTZ();
  
! 			assertEquals(4, stmt.executeUpdate("DELETE FROM " + TSWOTZ_TABLE));
  
  			stmt.close();
  		}
--- 177,203 ----
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + TS2WOTZ_PGFORMAT + "'")));
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + TS3WOTZ_PGFORMAT + "'")));
  			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + TS4WOTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + TS1WOTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + TS2WOTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + TS3WOTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + TS4WOTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + TS1WOTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + TS2WOTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + TS3WOTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + TS4WOTZ_PGFORMAT + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + new java.sql.Timestamp(tmpDate1WOTZ.getTime()) + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + new java.sql.Timestamp(tmpDate2WOTZ.getTime()) + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + new java.sql.Timestamp(tmpDate3WOTZ.getTime()) + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + new java.sql.Timestamp(tmpDate4WOTZ.getTime()) + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + new java.sql.Timestamp(tmpTime1WOTZ.getTime()) + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + new java.sql.Timestamp(tmpTime2WOTZ.getTime()) + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + new java.sql.Timestamp(tmpTime3WOTZ.getTime()) + "'")));
+ 			assertEquals(1, stmt.executeUpdate(TestUtil.insertSQL(TSWOTZ_TABLE, "'" + new java.sql.Timestamp(tmpTime4WOTZ.getTime()) + "'")));												
  
  			// Fall through helper
  			timestampTestWOTZ();
  
! 			assertEquals(20, stmt.executeUpdate("DELETE FROM " + TSWOTZ_TABLE));
  
  			stmt.close();
  		}
*************** public class TimestampTest extends TestC
*** 160,169 ****
  			pstmt.setTimestamp(1, TS4WOTZ);
  			assertEquals(1, pstmt.executeUpdate());
  
  			// Fall through helper
  			timestampTestWOTZ();
  
! 			assertEquals(4, stmt.executeUpdate("DELETE FROM " + TSWOTZ_TABLE));
  
  			pstmt.close();
  			stmt.close();
--- 233,283 ----
  			pstmt.setTimestamp(1, TS4WOTZ);
  			assertEquals(1, pstmt.executeUpdate());
  
+ 
+ 			// With java.sql.Timestamp
+ 			pstmt.setObject(1,TS1WOTZ, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			pstmt.setObject(1,TS2WOTZ, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			pstmt.setObject(1,TS3WOTZ, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());			
+ 			pstmt.setObject(1,TS4WOTZ, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			
+ 			// With Strings
+ 			pstmt.setObject(1,TS1WOTZ_PGFORMAT, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			pstmt.setObject(1,TS2WOTZ_PGFORMAT, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			pstmt.setObject(1,TS3WOTZ_PGFORMAT, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());			
+ 			pstmt.setObject(1,TS4WOTZ_PGFORMAT, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 
+ 			// With java.sql.Date
+ 			pstmt.setObject(1,tmpDate1WOTZ, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			pstmt.setObject(1,tmpDate2WOTZ, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			pstmt.setObject(1,tmpDate3WOTZ, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());			
+ 			pstmt.setObject(1,tmpDate4WOTZ, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 		
+ 			// With java.sql.Time	
+ 			pstmt.setObject(1,tmpTime1WOTZ, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			pstmt.setObject(1,tmpTime2WOTZ, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());
+ 			pstmt.setObject(1,tmpTime3WOTZ, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());			
+ 			pstmt.setObject(1,tmpTime4WOTZ, java.sql.Types.TIMESTAMP);
+ 			assertEquals(1, pstmt.executeUpdate());															
+ 
  			// Fall through helper
  			timestampTestWOTZ();
  
! 			assertEquals(20, stmt.executeUpdate("DELETE FROM " + TSWOTZ_TABLE));
  
  			pstmt.close();
  			stmt.close();
*************** public class TimestampTest extends TestC
*** 183,210 ****
  		ResultSet rs;
  		java.sql.Timestamp t;
  
! 		rs = stmt.executeQuery("select ts from " + TSWTZ_TABLE + " order by ts");
  		assertNotNull(rs);
  
  		assertTrue(rs.next());
  		t = rs.getTimestamp(1);
  		assertNotNull(t);
! 		assertTrue(t.equals(TS1WTZ));
  
  		assertTrue(rs.next());
  		t = rs.getTimestamp(1);
  		assertNotNull(t);
! 		assertTrue(t.equals(TS2WTZ));
  
  		assertTrue(rs.next());
  		t = rs.getTimestamp(1);
  		assertNotNull(t);
! 		assertTrue(t.equals(TS3WTZ));
  
  		assertTrue(rs.next());
  		t = rs.getTimestamp(1);
  		assertNotNull(t);
! 		assertTrue(t.equals(TS4WTZ));
  
  		assertTrue(! rs.next()); // end of table. Fail if more entries exist.
  
--- 297,369 ----
  		ResultSet rs;
  		java.sql.Timestamp t;
  
! 		rs = stmt.executeQuery("select ts from " + TSWTZ_TABLE); //removed the order by ts
  		assertNotNull(rs);
  
+ 		for (int i=0; i<3; i++)
+ 		{
+ 			assertTrue(rs.next());
+ 			t = rs.getTimestamp(1);
+ 			assertNotNull(t);
+ 			assertTrue(t.equals(TS1WTZ));
+ 	
+ 			assertTrue(rs.next());
+ 			t = rs.getTimestamp(1);
+ 			assertNotNull(t);
+ 			assertTrue(t.equals(TS2WTZ));
+ 	
+ 			assertTrue(rs.next());
+ 			t = rs.getTimestamp(1);
+ 			assertNotNull(t);
+ 			assertTrue(t.equals(TS3WTZ));
+ 	
+ 			assertTrue(rs.next());
+ 			t = rs.getTimestamp(1);
+ 			assertNotNull(t);
+ 			assertTrue(t.equals(TS4WTZ));
+ 		}
+ 		
+ 		// Testing for Date
  		assertTrue(rs.next());
  		t = rs.getTimestamp(1);
  		assertNotNull(t);
! 		assertEquals(t.getTime(), tmpDate1.getTime());
  
  		assertTrue(rs.next());
  		t = rs.getTimestamp(1);
  		assertNotNull(t);
! 		assertEquals(t.getTime(), tmpDate2.getTime());
  
  		assertTrue(rs.next());
  		t = rs.getTimestamp(1);
  		assertNotNull(t);
! 		assertEquals(t.getTime(), tmpDate3.getTime());
  
  		assertTrue(rs.next());
  		t = rs.getTimestamp(1);
  		assertNotNull(t);
! 		assertEquals(t.getTime(), tmpDate4.getTime());
! 		
! 		// Testing for Time
! 		assertTrue(rs.next());
! 		t = rs.getTimestamp(1);
! 		assertNotNull(t);
! 		assertEquals(t.getTime(), tmpTime1.getTime());
! 
! 		assertTrue(rs.next());
! 		t = rs.getTimestamp(1);
! 		assertNotNull(t);
! 		assertEquals(t.getTime(), tmpTime2.getTime());
! 
! 		assertTrue(rs.next());
! 		t = rs.getTimestamp(1);
! 		assertNotNull(t);
! 		assertEquals(t.getTime(), tmpTime3.getTime());
! 
! 		assertTrue(rs.next());
! 		t = rs.getTimestamp(1);
! 		assertNotNull(t);
! 		assertEquals(t.getTime(), tmpTime4.getTime());		
  
  		assertTrue(! rs.next()); // end of table. Fail if more entries exist.
  
*************** public class TimestampTest extends TestC
*** 221,249 ****
  		ResultSet rs;
  		java.sql.Timestamp t;
  
! 		rs = stmt.executeQuery("select ts from " + TSWOTZ_TABLE + " order by ts");
  		assertNotNull(rs);
  
  		assertTrue(rs.next());
  		t = rs.getTimestamp(1);
  		assertNotNull(t);
! 		assertTrue(t.equals(TS1WOTZ));
  
  		assertTrue(rs.next());
  		t = rs.getTimestamp(1);
  		assertNotNull(t);
! 		assertTrue(t.equals(TS2WOTZ));
  
  		assertTrue(rs.next());
  		t = rs.getTimestamp(1);
  		assertNotNull(t);
! 		assertTrue(t.equals(TS3WOTZ));
  
  		assertTrue(rs.next());
  		t = rs.getTimestamp(1);
  		assertNotNull(t);
! 		assertTrue(t.equals(TS4WOTZ));
  
  		assertTrue(! rs.next()); // end of table. Fail if more entries exist.
  
  		rs.close();
--- 380,453 ----
  		ResultSet rs;
  		java.sql.Timestamp t;
  
! 		rs = stmt.executeQuery("select ts from " + TSWOTZ_TABLE); //removed the order by ts
  		assertNotNull(rs);
  
+ 		for (int i=0; i<3; i++)
+ 		{
+ 			assertTrue(rs.next());
+ 			t = rs.getTimestamp(1);
+ 			assertNotNull(t);
+ 			assertTrue(t.equals(TS1WOTZ));
+ 	
+ 			assertTrue(rs.next());
+ 			t = rs.getTimestamp(1);
+ 			assertNotNull(t);
+ 			assertTrue(t.equals(TS2WOTZ));
+ 	
+ 			assertTrue(rs.next());
+ 			t = rs.getTimestamp(1);
+ 			assertNotNull(t);
+ 			assertTrue(t.equals(TS3WOTZ));
+ 	
+ 			assertTrue(rs.next());
+ 			t = rs.getTimestamp(1);
+ 			assertNotNull(t);
+ 			assertTrue(t.equals(TS4WOTZ));
+ 		}
+ 		
+ 		// Testing for Date
+ 		assertTrue(rs.next());
+ 		t = rs.getTimestamp(1);
+ 		assertNotNull(t);
+ 		assertEquals(t.getTime(), tmpDate1WOTZ.getTime());
+ 
+ 		assertTrue(rs.next());
+ 		t = rs.getTimestamp(1);
+ 		assertNotNull(t);
+ 		assertEquals(t.getTime(), tmpDate2WOTZ.getTime());
+ 
  		assertTrue(rs.next());
  		t = rs.getTimestamp(1);
  		assertNotNull(t);
! 		assertEquals(t.getTime(), tmpDate3WOTZ.getTime());
  
  		assertTrue(rs.next());
  		t = rs.getTimestamp(1);
  		assertNotNull(t);
! 		assertEquals(t.getTime(), tmpDate4WOTZ.getTime());
! 		
! 		// Testing for Time
! 		assertTrue(rs.next());
! 		t = rs.getTimestamp(1);
! 		assertNotNull(t);
! 		assertEquals(t.getTime(), tmpTime1WOTZ.getTime());
  
  		assertTrue(rs.next());
  		t = rs.getTimestamp(1);
  		assertNotNull(t);
! 		assertEquals(t.getTime(), tmpTime2WOTZ.getTime());
  
  		assertTrue(rs.next());
  		t = rs.getTimestamp(1);
  		assertNotNull(t);
! 		assertEquals(t.getTime(), tmpTime3WOTZ.getTime());
  
+ 		assertTrue(rs.next());
+ 		t = rs.getTimestamp(1);
+ 		assertNotNull(t);
+ 		assertEquals(t.getTime(), tmpTime4WOTZ.getTime());		
+ 		
  		assertTrue(! rs.next()); // end of table. Fail if more entries exist.
  
  		rs.close();
*************** public class TimestampTest extends TestC
*** 311,315 ****
--- 515,538 ----
  
  	private static final String TSWTZ_TABLE = "testtimestampwtz";
  	private static final String TSWOTZ_TABLE = "testtimestampwotz";
+ 	
+ 	private static final java.sql.Date tmpDate1 = new java.sql.Date(TS1WTZ.getTime());
+ 	private static final java.sql.Time tmpTime1 = new java.sql.Time(TS1WTZ.getTime());
+ 	private static final java.sql.Date tmpDate2 = new java.sql.Date(TS2WTZ.getTime());
+ 	private static final java.sql.Time tmpTime2 = new java.sql.Time(TS2WTZ.getTime());
+ 	private static final java.sql.Date tmpDate3 = new java.sql.Date(TS3WTZ.getTime());
+ 	private static final java.sql.Time tmpTime3 = new java.sql.Time(TS3WTZ.getTime());
+ 	private static final java.sql.Date tmpDate4 = new java.sql.Date(TS4WTZ.getTime());
+ 	private static final java.sql.Time tmpTime4 = new java.sql.Time(TS4WTZ.getTime());	
+ 	
+ 	private static final java.sql.Date tmpDate1WOTZ = new java.sql.Date(TS1WOTZ.getTime());
+ 	private static final java.sql.Time tmpTime1WOTZ = new java.sql.Time(TS1WOTZ.getTime());
+ 	private static final java.sql.Date tmpDate2WOTZ = new java.sql.Date(TS2WOTZ.getTime());
+ 	private static final java.sql.Time tmpTime2WOTZ = new java.sql.Time(TS2WOTZ.getTime());
+ 	private static final java.sql.Date tmpDate3WOTZ = new java.sql.Date(TS3WOTZ.getTime());
+ 	private static final java.sql.Time tmpTime3WOTZ = new java.sql.Time(TS3WOTZ.getTime());
+ 	private static final java.sql.Date tmpDate4WOTZ = new java.sql.Date(TS4WOTZ.getTime());
+ 	private static final java.sql.Time tmpTime4WOTZ = new java.sql.Time(TS4WOTZ.getTime());	
+ 
  
  }
